//
//  DBHandle.h
//  Freem
//
//  Created by mulp on 04/03/13.
//  author: Fabio Cuomo : me@devme.it
//

#import <Foundation/Foundation.h>
#import <sqlite3.h>
#import "Thread.h"
#import "Message.h"

/* Define database name */
extern NSString * const databaseName;

@interface DBHandle : NSObject {
	/* Database variables */
	NSString *databasePath;
    
	/* Database handle */
	sqlite3 *dbconn;
}

@property (nonatomic, retain) NSString *databasePath;

/**
 * Get singleton instance of this class, or rather
 * the only database handle.
 */
+(DBHandle*) sharedInstance;

/**
 * Connect to database.
 */
-(int) connectDB;

/**
 * Disconnect to database.
 */
-(void) disconnectDB;

-(BOOL) isClientRegistered;
-(NSMutableArray*) getThreads;
-(NSMutableArray*) retrieveConversation: (int)idthread;
-(BOOL) registerClient: (NSString*) privateKey;
-(int) registerLocalMessage:(NSString *)msg idthread:(int)idthread;
-(BOOL) registerUnreadMessage:(NSString *)msg idthread:(int)idthread tstamp:(int)tstamp;
-(NSString*) getSetting: (NSString*)pref;
-(BOOL) setSetting: (NSString*) pref value:(NSString*)value;

-(int) getThreadIdByPhone:(NSString*)phone;
-(int) startNewThread:(NSString*)phone;
-(BOOL)updateThread:(NSString*)phone;
@end
