
//
//  LoginViewController.m
//  Freem
//
//  Created by mulp on 06/03/13.
//  author: Fabio Cuomo : me@devme.it
//

#import "LoginViewController.h"

@interface LoginViewController () {
    DBHandle *dbhandle;
    UIActivityIndicatorView *spinner;
}

@end

@implementation LoginViewController

@synthesize threadViewController;

- (void)viewDidLoad {
    [super viewDidLoad];
    self.url.text = @"http://miohost/freem";
    self.phone.text = @"+39";
    self.navigationItem.title = @"FreeM";
    self.url.delegate = self;
    self.phone.delegate = self;
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

-(BOOL)textFieldShouldReturn:(UITextField *)textField {
    [textField resignFirstResponder];
    return YES;
}

- (IBAction)login:(id)sender {
    spinner = [[UIActivityIndicatorView alloc] initWithActivityIndicatorStyle:UIActivityIndicatorViewStyleWhiteLarge];
    [spinner setCenter:CGPointMake(320/2.0, 480/2.0)]; // I do this because I'm in landscape mode
    [self.view addSubview:spinner];
    [spinner startAnimating];
    
    [self.url resignFirstResponder];
    [self.phone resignFirstResponder];
    
    Settings *settings = [Settings sharedInstance];
    settings.serverBaseUrl = self.url.text;
    
    if (settings.tokenKey==nil || [settings.tokenKey isEqualToString:@""]) {
        showErrorAlert(NSLocalizedString(@"Errore durante la connessione. Riprova più tardi.", nil));
        [spinner stopAnimating];
    } else {
        ServerCalls *serverCalls = [ServerCalls sharedInstance];
        NSURLConnection *conn =  [serverCalls register:self.url.text phoneNumber:self.phone.text
                                                                    deviceId:settings.tokenKey delegate:self];
        if (!conn) {
            showErrorAlert(NSLocalizedString(@"Errore durante la connessione. Riprova più tardi.", nil));
            [spinner stopAnimating];
        }
    }
}

- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data {
    NSLog(@"didReceiveData");
    NSString* resp = [NSString stringWithUTF8String:[data bytes]];
    NSLog(@"Data: %@", resp);
    
    NSError* error;
    NSDictionary* json = [NSJSONSerialization JSONObjectWithData:data
                          options:kNilOptions error:&error];
    
    [spinner stopAnimating];
    
    NSNumber *code = [json objectForKey:@"code"];
    if ([code intValue]==0) {
        NSDictionary *result = [json objectForKey:@"result"];

        // Store in settings main preferences
        Settings *settings = [Settings sharedInstance];
        settings.phone = self.phone.text;
        settings.privateKey = [result objectForKey:@"private_key"];
        
        // create the MyView controller instance:
//        FreeMViewController *mainViewController = [[FreeMViewController alloc] initWithNibName:@"FreeMView" bundle:nil];
//        
//        // set the title that appears in the navigation bar:
//        [mainViewController.navigationItem setTitle:@"Free Message"];
        
        self.navigationItem.hidesBackButton = YES;
        [self.navigationController pushViewController:self.threadViewController animated:YES];
    } else {
        NSString *description = [json objectForKey:@"description"];
        showErrorAlert(NSLocalizedString(description, nil));
    }
    
    NSString* newStr = [NSString stringWithUTF8String:[data bytes]];
    NSLog(@"%@", newStr);
}

@end
