//
//  RetrieveMessageDelegate.m
//  Freem
//
//  Created by mulp on 10/03/13.
//  author: Fabio Cuomo : me@devme.it
//

#import "RetrieveMessageDelegate.h"

@implementation RetrieveMessageDelegate

@synthesize threadViewController;

- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data {
    // Risposta da parte del server. Endpoint recupero messaggio
    NSString* resp = [NSString stringWithUTF8String:[data bytes]];
    NSLog(@"retrieve response: %@", resp);
    
    NSError* error;
    int firstThread = 0;
    BOOL threadChanged = NO;
    NSString *sender;
    
    // JSON della risposta
    NSDictionary* json = [NSJSONSerialization JSONObjectWithData:data
                                                         options:kNilOptions error:&error];
    NSNumber *code = [json objectForKey:@"code"];
    if ([code intValue]==0) {
        NSDictionary *result = [json objectForKey:@"result"];
        
        DBHandle *dbhandle = [DBHandle sharedInstance];
        NSArray *messages = [result objectForKey:@"messages"];
        for (NSDictionary *msg in messages) {
            sender = [msg objectForKey:@"sender"];
            NSString *contact = @"";
            if (sender!=nil && ![sender isEqualToString:@""]) {
                contact = [Utility retrieveContactNameFromAddressBookByPhone:sender];
            } else {
                contact = sender;
            }
            int idthread = [dbhandle getThreadIdByPhone:sender];
            if (idthread==0) {
                idthread = [dbhandle startNewThread:sender];
            } else {
                [dbhandle updateThread:sender];
            }
            
            // Salvo il primo thread id ricevuto
            if (firstThread==0) {
                firstThread = idthread;
            }            
            NSString *tstamp = [msg objectForKey:@"ts_sent"];
            NSRange range = [tstamp rangeOfString:@"+"];
            
            NSString *tstampWithoutZone = [[tstamp substringWithRange:NSMakeRange(0, NSMaxRange(range)-1)]
                                           stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceCharacterSet]];
            
            NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
            [dateFormatter setDateFormat:@"yyyy/MM/dd HH:mm:ss"];
            NSDate *date = [dateFormatter dateFromString:tstampWithoutZone];
            NSTimeInterval ts = [date timeIntervalSince1970];
            NSLog(@"Time is: %d", [[NSNumber numberWithDouble:ts] intValue]);
            
            [dbhandle registerUnreadMessage:[msg objectForKey:@"message"] idthread:idthread tstamp:[[NSNumber numberWithDouble:ts] intValue]];
            if (idthread!=firstThread) {
                threadChanged = YES;
            }
        }
        if (threadChanged) {
            [self.threadViewController incomingMessages:firstThread phone:sender];
        } else {
            [self.threadViewController didSaveMessage:firstThread phone:sender];
        }
    } else {
        NSString *description = [json objectForKey:@"description"];
        showErrorAlert(NSLocalizedString(description, nil));
    }
}

@end
