//
//  Utility.m
//  Freem
//
//  Created by mulp on 12/03/13.
//  author: Fabio Cuomo : me@devme.it
//

#import "Utility.h"

@implementation Utility

+ (NSString *)retrieveContactNameFromAddressBookByPhone:(NSString *)phone {
    CFErrorRef error;
    ABAddressBookRef addressBook = ABAddressBookCreateWithOptions(NULL, &error);
    NSArray *people = (__bridge NSArray *) ABAddressBookCopyArrayOfAllPeople(addressBook);
    
    // Build a predicate that searches for contacts with at least one phone number starting with (408).
    NSPredicate* predicate = [NSPredicate predicateWithBlock: ^(id record, NSDictionary* bindings) {
        ABMultiValueRef phoneNumbers = ABRecordCopyValue( (__bridge ABRecordRef)record, kABPersonPhoneProperty);
        BOOL result = NO;
        
        for (CFIndex i = 0; i < ABMultiValueGetCount(phoneNumbers); i++) {
            NSString* phoneNumber = (__bridge_transfer NSString*) ABMultiValueCopyValueAtIndex(phoneNumbers, i);
            if ([phoneNumber isEqualToString:phone]) {
                NSLog(@"Name is: %@", (__bridge NSString *) ABRecordCopyValue((__bridge ABRecordRef)record, kABPersonFirstNameProperty));
                result = YES;
                break;
            }
        }
        CFRelease(phoneNumbers);
        return result;
    }];
    NSArray* filteredContacts = [people filteredArrayUsingPredicate:predicate];
    if ([filteredContacts count]>0) {
        ABRecordRef ref = (__bridge ABRecordRef) [filteredContacts objectAtIndex:0];
        NSString *cfirst = (__bridge NSString *) ABRecordCopyValue(ref, kABPersonFirstNameProperty);
        NSString *clast = (__bridge NSString *) ABRecordCopyValue(ref, kABPersonLastNameProperty);
        NSString *cname = @"";
        if ([cfirst length]>0) {
            cname = [cname stringByAppendingString:cfirst];
        }
        if ([clast length]>0) {
            if ([cname length]>0) {
                cname = [cname stringByAppendingString:@" "];
            }
            cname = [cname stringByAppendingString:clast];
        }
        return cname;
    }
    return phone;
}
@end
