//
//  Settings.m
//  Freem
//
//  Created by mulp on 09/03/13.
//  author: Fabio Cuomo : me@devme.it
//

#import "Settings.h"

@implementation Settings

@synthesize phone = _phone;
@synthesize tokenKey = _tokenKey;
@synthesize privateKey = _privateKey;
@synthesize serverBaseUrl = _serverBaseUrl;

static Settings *instance = nil;

+(Settings*) sharedInstance {
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        instance = [[self alloc] init];
    });
    return instance;
}

-(id) init {
	self = [super init];
	if (self != nil) {
        DBHandle *dbhandle = [DBHandle sharedInstance];
        self.phone = [dbhandle getSetting:@"PHONE_NUMBER"];
        self.tokenKey = [dbhandle getSetting:@"TOKEN_KEY"];
        self.privateKey = [dbhandle getSetting:@"PRIVATE_KEY"];
        self.serverBaseUrl = [dbhandle getSetting:@"SERVER_URL"];
	}
	return self;
}

-(BOOL)updateTokenKey:(NSString *)newToken {
    BOOL result = YES;
    self.tokenKey = newToken;
    ServerCalls *serverCall = [ServerCalls sharedInstance];
    [serverCall register:self.serverBaseUrl phoneNumber:self.phone deviceId:self.privateKey delegate:self];
    return result;
}
-(BOOL)isClientRegistered {
    return ![self.privateKey isEqualToString:@""];
}

-(void)setPhone:(NSString *)phone {
    DBHandle *dbhabdle = [DBHandle sharedInstance];
    [dbhabdle setSetting:@"PHONE_NUMBER" value:phone];
    _phone = phone;
}

-(void)setTokenKey:(NSString *)tokenKey {
    DBHandle *dbhabdle = [DBHandle sharedInstance];
    [dbhabdle setSetting:@"TOKEN_KEY" value:tokenKey];
    _tokenKey = tokenKey;
}

-(void)setPrivateKey:(NSString *)privateKey {
    DBHandle *dbhabdle = [DBHandle sharedInstance];
    [dbhabdle setSetting:@"PRIVATE_KEY" value:privateKey];
    _privateKey = privateKey;
}

-(void)setServerBaseUrl:(NSString *)serverBaseUrl {
    DBHandle *dbhabdle = [DBHandle sharedInstance];
    [dbhabdle setSetting:@"SERVER_URL" value:serverBaseUrl];
    _serverBaseUrl = serverBaseUrl;
}

- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data {
    NSLog(@"didReceiveData");
    NSString* resp = [NSString stringWithUTF8String:[data bytes]];
    NSLog(@"Data: %@", resp);    
}
@end
